\\ Modified Pollard p-1 method. Usage pollard(n,t) where n is the
\\ number to be factored and t is the size of the factor base 
\\ ie the first t primes. Adjust to taste.
\\ Modified to handle case where p-1 is smooth for all p|n
\\ By Felipe Voloch.


pollard(n:int,t:small)=
{
 	local(m:small,b:int,p,j:small,d:int,g:int,lgn:mp);
        until(b,b=random()%n);
        if(n<=1,error("Invalid input"));
        g=gcd(b,n);
        if(g>1,print(g," is a factor of ",n),
        p=3;j=1;d=1;lgn=log(n):mp;
        while(d==1&&j<=t,
                b=lift(Mod(b,n)^(p^floor(lgn/log(p)))):int;
                d=gcd(b-1,n);
                        if(d>1&&d<n,print(d," is a factor of ",n));
                        j++;p=nextprime(p++));m=1;
    			while(d==1&&m<=floor(lgn/log(2)),b=lift(Mod(b,n)^2):int;
		d=gcd(b-1,n);if(d>1&&d<n,print(d," is a factor of ",n));m++);
                        if(d==1||d==n,print("Try increasing t")))
}


